import it.unimi.dsi.fastutil.doubles.DoubleArrayList;
import tsdb.TsdbApiEntry;
import tsdb.TsdbApiEntryStream;

import java.util.ArrayList;

public class TestRun {
    public static void main(String[] args) {
        TsdbApiEntry db = new TsdbApiEntry();
        // 设置 metric 名称
        db.setMetricName("test_java_metric1");
        // 设置数据存储目录
        db.setDataDir("/tmp/tsdb_data/");
        // 设置每 1_000_000 个数据进行一次分片存盘
        db.setPartSize(1_000_000);
        // 新建传感器名为 test_java_pt1 的 stream 对象，从 UTC 时间 1000000 毫秒开始，两点间的时间间隔为 5000 纳秒
        long startTime = System.currentTimeMillis();
        try (TsdbApiEntryStream stream = db.newStream("test_java_pt1", 1000000, 5000)) {
            // 批量插入 8 个数据点（不推荐此方式；如需调用，请直接使用 DoubleArrayList 来避免数据拷贝）
            {
                ArrayList<Double> data = new ArrayList<>();
                for (int i = 0; i < 8; i++) {
                    data.add(0.1 + 0.1 * i);
                }
                stream.insertPoints(new DoubleArrayList(data));
            }
            // 插入 10_000_000 个数据点
            for (int i = 0; i < 10_000_000; i++) {
                stream.insertPoint(4.2 + i);
            }
        }
        long endTime = System.currentTimeMillis();
        System.out.println("Time cost: " + (endTime - startTime) + " ms");
        System.out.println("All success!");
    }
}
